﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "numru/ggraph"
include NumRu

dir  = ARGV[0]
dir2 = ARGV[1]
dir3 = ARGV[2]
vname = ARGV[3]
iyrs = ARGV[4].to_i
iyre = ARGV[5].to_i
lat = ARGV[6].to_i
lon = ARGV[7].to_i
ls = ARGV[8].to_i
days = ARGV[9].to_i
non_observation_switch = ARGV[10].to_s

if non_observation_switch == 'true'
  non_observation_switch = true
else
  non_observation_switch = false
end

time_array = ls_to_time(iyrs, iyre, dir, [ls])
lt_array = local_starting_time_and_ending_time(time_array[0],days, lon, dir)
#title = MonNames[imon-1]
p dir
p dir2
p dir3

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)
gphys2 = GPhys::NetCDF_IO.open(dir2+'/'+vname+".nc", vname)
gphys3 = GPhys::NetCDF_IO.open(dir3+'/'+vname+".nc", vname)

gphysout = gphys_to_frac(gphys2.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon),gphys.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon))

p gphysout
p gphysout.val

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う
DCL.uzlset('LOFFSET',true)   # 次の XOFFSET で軸の値のオフセットを取れるようにする
DCL.uzrset('XOFFSET',- gphys.cut("time"=>lt_array[0]..lt_array[1]).coord("time").val[0].to_i)
DCLExt.gl_set_params('lmiss'=>true) # 欠損値を使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
#GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('xlabelint'=>100)
#GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xtickint'=>4,'xlabelint'=>24)
GGraph.set_axes('xside'=>'t','xtickint'=>1,'xlabelint'=>4)


vmax = nil
vmin = nil
#if vname == 'DDAF_d'
#  if lat == -25 then
#  vmax = 40.0*10**(-11)
#  vmin = 0.0
#  elsif lat == 25
#    vmax = 24.0 *10**(-11)
#    vmin = 0.0
#  end
#elsif vname == 'Sens'
#  if lat == -25
#  vmax = 60
#  vmin = -5
#  elsif lat == 25
#    vmax = 40
#    vmin = -5
#  end
#elsif vname == 'Eta'
#  if lat == -25
#  vmax = 0.1
#  vmin = 0.0
#  elsif lat == 25
#    vmax = 0.09
#    vmin = 0.0
#  end
#elsif vname == 'Ps'
#  if lat == -25
#    vmax = 520
#    vmin = 690
#  elsif lat == 25
#    vmax = 620
#    vmin = 710
#  end
#elsif vname == 'Press_top'
#  #vmax = 200
#  vmax = 300
#  vmin = 700
#elsif vname == 'k_top'
#  vmax = 20
#end

# 作図

GGraph.line(gphysout, true, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat / zonal mean')

# 上下の座標軸を書く
DCL::uxaxdv('T',1,4)
DCL::uxaxdv('B',1,4)
DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
