﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "numru/ggraph"
include NumRu

dir  = ARGV[0]
dir2 = ARGV[1]
dir3 = ARGV[2]
vname = ARGV[3]
iyrs = ARGV[4].to_i
iyre = ARGV[5].to_i
lat = ARGV[6].to_i
lon = ARGV[7].to_i
ls = ARGV[8].to_i
days = ARGV[9].to_i
non_observation_switch = ARGV[10].to_s
individual_switch = ARGV[11].to_s

if non_observation_switch == 'true'
  non_observation_switch = true
else
  non_observation_switch = false
end

if individual_switch == 'true'
  individual_switch = true
else
  individual_switch = false
end

time_array = ls_to_time(iyrs, iyre, dir, [ls])
lt_array = local_starting_time_and_ending_time(time_array[0],days, lon, dir)
#title = MonNames[imon-1]
p dir
p dir2
p dir3

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)
gphys2 = GPhys::NetCDF_IO.open(dir2+'/'+vname+".nc", vname)
gphys3 = GPhys::NetCDF_IO.open(dir3+'/'+vname+".nc", vname)

gphysout = gphys_to_log(gphys.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon))
gphysout2 =  gphys_to_log(gphys2.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon))
gphysout3 =  gphys_to_log(gphys3.cut("time"=>lt_array[0]..lt_array[1],"lat"=>lat, "lon"=>lon))

p gphysout
p gphysout.val
if vname == 'DDAF_d'
# 効率因子分を引く
  gphysout = gphysout - log(1.0e-10)
  gphysout2 = gphysout2 - log(1.0e-10)
  gphysout3 = gphysout3 - log(1.0e-10)
end

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う
DCL.uzlset('LOFFSET',true)   # 次の XOFFSET で軸の値のオフセットを取れるようにする
DCL.uzrset('XOFFSET',- gphys.cut("time"=>lt_array[0]..lt_array[1]).coord("time").val[0].to_i) # 計算はじめの時間でオフセットを取り, 座標軸を0-24 に合わせる
DCLExt.gl_set_params('lmiss'=>true) #欠損値を使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
#GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('xlabelint'=>100)
#GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xtickint'=>4,'xlabelint'=>24)
GGraph.set_axes('xside'=>'t','xtickint'=>1,'xlabelint'=>4)


if individual_switch
  if vname == 'DDAF_d'
    if lat == -25 then
      vmax = 1.5
      vmin = -6.5
    elsif lat == 25
      vmax = 1
      vmin = -7
    end
  elsif vname == 'SensB'
    if lat == -25
      vmax = 4.5
      vmin = -1
    elsif lat == 25
      vmax = 4
      vmin = -1.5
    end
  elsif vname == 'Eta'
    if lat == -25
      vmax = -2
      vmin = -9
    elsif lat == 25
      vmax = -2
      vmin = -9.5
    end
  end
else
  if lat == -25
    vmax = 4.5
    vmin = -9
  elsif lat == 25
    vmax = 4
    vmin = -9.5
  end
end


# 作図
#GGraph.line(gphyscal,true, 'index'=>21, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false)
#GGraph.line(gphyscal2,false, 'index'=>11, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false)
#GGraph.line(gphyscal3,false, 'index'=>41, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false)

GGraph.line(gphysout,true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
GGraph.line(gphysout2,false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')
unless non_observation_switch
  GGraph.line(gphysout3,false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
end

##GGraph.line(gphys.cut("time"=>60600..60720,"lat"=>lat, "lon"=>0),true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
##GGraph.line(gphys2.cut("time"=>60600..60720,"lat"=>lat, "lon"=>0),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
##GGraph.line(gphys3.cut("time"=>60600..60720,"lat"=>lat, "lon"=>0),false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')
#
#GGraph.line(gphys.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
##GGraph.line(gphys2.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
#GGraph.line(gphys3.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')
##GGraph.line(gphys.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0)[false,0,true],true, 'index'=>21, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'flat')
##GGraph.line(gphys2.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0),false, 'index'=>11, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'observation')
##GGraph.line(gphys3.cut("time"=>52824..52944,"lat"=>lat, "lon"=>0)[false,0,true],false, 'index'=>41, 'type'=>1, 'max'=> vmax, 'min'=> vmin, 'annotate'=>false, 'legend'=>'zonal mean')

# 上下の座標軸を書く
DCL::uxaxdv('T',1,4)
DCL::uxaxdv('B',1,4)

# タイトルの指定
DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
