﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "gphys_tmp_calc"
require "numru/ggraph"
include NumRu

dir  = ARGV[0].dup.to_s
vname_array = []
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
lat = ARGV[4].to_i
lon = ARGV[5].to_i
ls = ARGV[6].to_i
days = ARGV[7].to_i
local_time = ARGV[8].to_i
unit = ARGV[9].to_s
legend_array = []
index_array = []
ls_dir = ARGV[12].dup.to_s
overwrite_topog_switch = ARGV[13].dup.to_s
ogihara_script_switch = ARGV[14].dup.to_s

ARGV[1].split("!").each do |vname|
  vname_array << vname.to_s
end
ARGV[10].split("!").each do |legend|
  if legend == "true"
      legend_array << true
  elsif /_SPACE_/ =~ legend
    legend_array << legend.gsub(/_SPACE_/, ' ').to_s
  else
    legend_array << legend.to_s
  end
end
ARGV[11].split("_").each do |index_comp|
  index_array << index_comp.to_s
end
if overwrite_topog_switch == 'true'
  overwrite_topog_switch = true
  sp_dir = ARGV[15].dup.to_s
  sp_file = ARGV[16].dup.to_s
  sp_vname = ARGV[17].dup.to_s
#  ext_time(iyrs, iyre, sp_dir, sp_file, sp_vname, dir, vname, vname)
  sp_dir = add_slash(sp_dir)
  sp = GPhys::IO.open(sp_dir + sp_file+ '.nc', sp_vname)
else
  overwrite_topog_switch = false
end

if ogihara_script_switch == 'true'
  ogihara_script_switch = true
else
  ogihara_script_switch = false
end


time_array = ls_to_time(iyrs, iyre, ls_dir, [ls])
lt_array = local_starting_time_and_ending_time(time_array[0],days, lon, ls_dir)
  


#title = MonNames[imon-1]
gphys_array = []
num_array = []
vname_array.each_with_index do |vnames,num|
  p num
  p vnames
  array = diff(vnames)
  vname = array[0]
  p array[0]
  p array[1]
  gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname).dup
  if gphys.axnames[-1] == 'PlanetLonFromVE' || gphys.axnames[-1] == 'Ls'
    ls_dir = add_slash(ls_dir)
    ls = GPhys::IO.open(ls_dir+'PlanetLonFromVE.nc','PlanetLonFromVE')
    lt_array[0] = ls.cut("time"=>lt_array[0]).val[0]
    lt_array[1] = ls.cut("time"=>lt_array[1]).val[0]
    gphys_array << gphys_to_log(gphys.cut(gphys.axnames[-1]=>lt_array[0]..lt_array[1],"lat"=>lat).mean(-1))
  else
    if ogihara_script_switch
      gphys = select_gphys(gphys.cut("time"=>lt_array[0]..lt_array[1]),dir,vname, nil,lt_array[0],lt_array[1],array[1])
      gphysout =  gphys_to_log(local_time_mean(lt_array[0], lt_array[1], gphys.cut("lat"=>lat), local_time, unit, days))
      if vname == 'DDAF_d'
        gphysout = gphysout - log(1.0e-10)
      elsif array[1] == 'sensb-cp'
        gphysout = gphysout - log(Cp)
        num_array << num.to_s.dup
      elsif array[1] == 'diff_pottemp_plus_rho'
        num_array << num.to_s.dup
      elsif array[1] == 'rho'
        p 'test2'
        num_array <<  num.to_s.dup
      elsif array[1] == 'total'
        gphysout3 = 0
        gphysout4 = 0
        p num_array[0]
        p num_array[1]
        p num_array[2]
        gphys_array.each_with_index do |gphysout2, idx|
          unless num_array[0].to_i == idx.to_i
            p gphysout2
            gphysout3 = gphysout3 + gphysout2
              p gphysout3
          end
          if num_array[1]
            if num_array[1].to_i == idx.to_i
              gphysout4 = gphysout4 + gphysout2
              p gphysout4
            elsif num_array[2].to_i == idx.to_i
              gphysout4 = gphysout4 + gphysout2
              p gphysout4
            end
          end
        end
        gphysout = gphysout3
        if num_array[1]
          gphys_array[num_array[1].to_i] = gphysout4
        end
        if num_array[2]
          gphys_array.delete_at(num_array[2].to_i)
        end
      end
      gphys_array << gphysout
    end
  end
end


#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig('viewport'=>[0.1,0.9,0.1,0.9])
GGraph.set_fig('viewport'=>[0.1,0.8,0.1,0.9])
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
GGraph.set_axes('yside'=>'l','xtickint'=>5, 'xlabelint'=>30)



vmax = nil
vmin = nil
#vmax = 4.5
#vmin = -3.5
vmax = 5.2
vmin = -5.5
index = 21
type = 1
#if vname == 'DDAF_d'
#  if lat == -25 || lat == -30
#    vmax = 80.0*10**(-12)
#  else
#  vmax = 60.0*10**(-12)
#  end
#  vmin = 0.0
#elsif vname == 'Sens'
#  if lat == -25 || lat == -30
#    vmax = 13
#  else
#  vmax = 10.4
#  end
#  vmin = 1.0
#elsif vname == 'Eta'
#  vmax = 26 * 0.001
#  vmin = 0.0
#end

# 作図
if index_array[0] == "true"
  gphys_array.each_with_index do |gphysmean, num| 
    p legend_array[num]
    # max 値と min 値を表示
    print("max:", gphysmean.max)
    print("min:", gphysmean.min, "\n")
    if num == 0
      GGraph.line(gphysmean,true, 'index'=>index, 'type'=>type,  'legend'=>legend_array[num], 'max'=>vmax, 'min'=>vmin,'annotate'=>false)
    else
      GGraph.line(gphysmean,false, 'index'=>index, 'type'=>type,  'legend'=>legend_array[num], 'max'=>vmax, 'min'=>vmin,'annotate'=>false)
    end
    index +=10
  end
else
  gphys_array.each_with_index do |gphysmean, num|
    p gphysmean
    p legend_array[num]
    # max 値と min 値を表示
    print("max:", gphysmean.max)
    print("min:", gphysmean.min, "\n")
    if num == 0
      GGraph.line(gphysmean,true, 'index'=>index_array[num], 'type'=>type,  'legend'=>legend_array[num], 'max'=>vmax, 'min'=>vmin,'annotate'=>false)
    else
      GGraph.line(gphysmean,false, 'index'=>index_array[num], 'type'=>type,  'legend'=>legend_array[num], 'max'=>vmax, 'min'=>vmin,'annotate'=>false)
    end
  end
end


if overwrite_topog_switch
  if (vname_array.include?('Ps') && (array[1] != 'exner_0' && array[1] != 'exner_1')) || vname_array.include?('Press_top') 
    if vname_array.include?('Ps')
      number = vname_array.index('Ps')
    else
      number = vname_array.index('Press_top')
    end
    gphysmean = gphys_array[number]
    if vmax
      gphysmax = vmax
      gphysmin = vmin
    else
      gphysmax = gphysmean.max.to_f
      gphysmin = gphysmean.min.to_f
    end
    factor = -(gphysmax - gphysmin)/(sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f)
    fixer = gphysmin - sp.cut("lat"=>lat).max.to_f * factor
    GGraph.line((sp.cut("lat"=>lat)*factor + fixer),false, 'index'=>1, 'annotate'=>false)
    DCL::uzlset('LABELYR',false)
    # 一時的に軸にラベルを入れられないようにする
    order = (sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f).abs.to_i.to_s.length - 1

    DCL::grswnd(0,360,sp.cut("lat"=>lat).max.to_f * 10**(- order),sp.cut("lat"=>lat).min.to_f * 10**(- order))
    # 軸の範囲の再設定
    DCL::uzlset('LABELYR',true)
    # 軸にラベルを入れ出れるようにする
    #DCL::uyaxdv('R',(sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f).div(20) * 10**(- order), (sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f).div(20)*10**(1 - order)) 
    DCL::uyaxdv('R',0.2, 1.0) # 実際に軸を描く. 第一引数は場所Rは右軸, 第二引数は小さなメモリ, 第三引数は大きなメモリとメモリの値を表示する場所
    DCL::uysttl('R', sp.name, 0.0)
    #DCLExt.uz_set_params('RSIZEC1'=>0.018,'IROTCXT'=>0, 'UYUSER'=>0.01, 'ROFFXU'=>0.63 )
    # RSIZEC1: タイトルの高さ(値が大きいほど文字が大きくなる), IROTCYR: Y軸右軸についての回転角, 'UYUSER'=> U座標のX軸の指定. 0.0  にするとおそらく ROFFXU で指定した位置に行く. 'ROFFXU': U(自分で指定する座標)座標のX軸の初期位置を指定(大きくするほど上へ行く)
    DCLExt.uz_set_params('RSIZEC1'=>0.018,'IROTCYU'=>0, 'UXUSER'=>0.01, 'ROFFYU'=>0.9 )
    #DCL::uxpttl('U',1,'(x' + (10**(order)).to_s+' m)', 1.0)
    # タイトルを書く, 第一引数にどの軸に書くか(uxpttl の場合 T(上軸),B(下軸),U(自分で指定した座標の軸) で選択. 第二引数は属性指定 (0 は uz_set_params の設定を全て自分で指定. 1 は基本小さい目盛設定,2は基本大きい目盛設定. もし uz_set_params で指定したパラメータがあった場合その値だけ変える), 第三引数は書くタイトル, 第4引数は軸のどこにあるか(-1(左端), 1 (右端)の間の数値で指定 
    DCL::uypttl('U',1,'(x ' + (-10**(order)).to_s+' m)', 1.0)
  else
    gphysmean = gphys_array[0]
    if vmax
      gphysmax = vmax
      gphysmin = vmin
    else
      gphysmax = gphysmean.max.to_f
      gphysmin = gphysmean.min.to_f
    end
    factor = (gphysmax - gphysmin)/(sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f)
    fixer = gphysmax - sp.cut("lat"=>lat).max.to_f * factor
    GGraph.line((sp.cut("lat"=>lat)*factor + fixer),false, 'index'=>1, 'annotate'=>false)
    DCL::uzlset('LABELYR',false)
    # 一時的に軸にラベルを入れられないようにする
    order = (sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f).abs.to_i.to_s.length - 1

    DCL::grswnd(0,360,sp.cut("lat"=>lat).min.to_f * 10**(- order),sp.cut("lat"=>lat).max.to_f * 10**(- order))
    # 軸の範囲の再設定
    DCL::uzlset('LABELYR',true)
    # 軸にラベルを入れ出れるようにする
    #DCL::uyaxdv('R',(sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f).div(20) * 10**(- order), (sp.cut("lat"=>lat).max.to_f - sp.cut("lat"=>lat).min.to_f).div(20)*10**(1 - order)) 
    DCL::uyaxdv('R',0.2, 1.0) # 実際に軸を描く. 第一引数は場所Rは右軸, 第二引数は小さなメモリ, 第三引数は大きなメモリとメモリの値を表示する場所
    DCL::uysttl('R', sp.name, 0.0)
    #DCLExt.uz_set_params('RSIZEC1'=>0.018,'IROTCXT'=>0, 'UYUSER'=>0.01, 'ROFFXU'=>0.63 )
    # RSIZEC1: タイトルの高さ(値が大きいほど文字が大きくなる), IROTCYR: Y軸右軸についての回転角, 'UYUSER'=> U座標のX軸の指定. 0.0  にするとおそらく ROFFXU で指定した位置に行く. 'ROFFXU': U(自分で指定する座標)座標のX軸の初期位置を指定(大きくするほど上へ行く)
    DCLExt.uz_set_params('RSIZEC1'=>0.018,'IROTCYU'=>0, 'UXUSER'=>0.01, 'ROFFYU'=>0.9 )
    #DCL::uxpttl('U',1,'(x' + (10**(order)).to_s+' m)', 1.0)
    # タイトルを書く, 第一引数にどの軸に書くか(uxpttl の場合 T(上軸),B(下軸),U(自分で指定した座標の軸) で選択. 第二引数は属性指定 (0 は uz_set_params の設定を全て自分で指定. 1 は基本小さい目盛設定,2は基本大きい目盛設定. もし uz_set_params で指定したパラメータがあった場合その値だけ変える), 第三引数は書くタイトル, 第4引数は軸のどこにあるか(-1(左端), 1 (右端)の間の数値で指定 
    DCL::uypttl('U',1,'(x ' + (10**(order)).to_s+' m)', 1.0)

  end
end

#DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
