﻿# -*- coding: utf-8 -*-
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_methods"
require "gphys_time"
require "gphys_tmp_calc"
require "numru/ggraph"
include NumRu

dir  = ARGV[0].dup.to_s
vname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
lat = ARGV[4].to_i
lon = ARGV[5].to_i
ls = ARGV[6].to_i
days = ARGV[7].to_i
ls_dir = ARGV[8].dup.to_s
overwrite_topog_switch = ARGV[9].dup.to_s

if overwrite_topog_switch == 'true'
  overwrite_topog_switch = true
  sp_dir = ARGV[10].dup.to_s
  sp_file = ARGV[11].dup.to_s
  sp_vname = ARGV[12].dup.to_s
  ext_time(iyrs, iyre, sp_dir, sp_file, sp_vname, dir, vname, vname)
  sp = GPhys::IO.open('./tmp/' + sp_file + '_ext_time.nc', sp_vname)
else
  overwrite_topog_switch = false
end

time_array = ls_to_time(iyrs, iyre, ls_dir, [ls])
lt_array = local_starting_time_and_ending_time(time_array[0],days, lon, ls_dir)
  


#title = MonNames[imon-1]
p dir

gphys = GPhys::NetCDF_IO.open(dir+'/'+vname+".nc", vname)
if gphys.axnames[-1] == 'PlanetLonFromVE' || gphys.axnames[-1] == 'Ls'
  ls_dir = add_slash(ls_dir)
  ls = GPhys::IO.open(ls_dir+'PlanetLonFromVE.nc','PlanetLonFromVE')
  lt_array[0] = ls.cut("time"=>lt_array[0]).val[0]
  lt_array[1] = ls.cut("time"=>lt_array[1]).val[0]
else
  unless gphys.coord("time").get_att('units') == 'sec'
GGraph.set_axes('ytickint'=>1, 'ylabelint'=>12)
  end
end

#< DCLのオープンと設定 >
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>10, 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_fig 'viewport'=>[0.15,0.85,0.1,0.6], 'window'=>[0,360,-90,90]
#GGraph.set_map 'coast_world'=>true, 'grid'=>false
#GGraph.set_axes('yside'=>'lr','xside'=>'tb')
#GGraph.set_axes('xlabelint'=>100)
GGraph.set_axes('xtickint'=>5, 'xlabelint'=>30)
#GGraph.set_axes('ylabelint'=>15)
#GGraph.set_axes('xtickint'=>4,'xlabelint'=>24)
#GGraph.set_axes('xlabelint'=>90)
#GGraph.set_axes('ylabelint'=>30)



#if vname == 'DDAF_d'
#  if lat == -25 || lat == -30
#    vmax = 80.0*10**(-12)
#  else
#  vmax = 60.0*10**(-12)
#  end
#  vmin = 0.0
#elsif vname == 'Sens'
#  if lat == -25 || lat == -30
#    vmax = 13
#  else
#  vmax = 10.4
#  end
#  vmin = 1.0
#elsif vname == 'Eta'
#  vmax = 26 * 0.001
#  vmin = 0.0
#end
if vname == 'Ps'
  levels = [100, 125, 150, 175, 200, 225, 250, 275, 300, 325, 350, 375, 400, 425, 450, 475, 500, 525, 550, 575, 600, 625, 650, 675, 700, 725, 750, 775, 800, 825, 850, 875, 900, 925, 950, 975, 1000, 1025, 1050, 1075, 1100, 1125, 1150, 1175, 1200, 1225, 1250, 1275, 1300, 1325, 1350, 1375, 1400, 1425, 1450, 1475, 1500]
  patterns = [0, 20999, 21999, 22999, 23999, 24999, 25999, 26999, 27999, 28999, 29999, 30999, 31999, 32999, 33999, 34999, 35999, 36999, 37999, 38999, 39999, 40999, 42999, 44999, 46999, 48999, 50999, 52999, 54999, 56999, 58999, 60999, 62999, 64999, 66999, 68999, 70999, 71999, 72999, 73999, 74999, 75999, 76999, 77999, 78999, 79999, 80999, 81999, 82999, 83999, 84999, 85999, 86999, 87999, 88999, 89999, 90999]
elsif vname =='DDAF_d'
  levels = [0.0e0, 0.90e-11, 1.80e-11, 2.70e-11, 3.60e-11, 4.50e-11, 5.4e-11, 6.30e-11, 7.20e-11, 8.10e-11, 9.0e-11, 9.9e-11, 1.08e-10, 1.17e-10, 1.26e-10, 1.35e-10, 1.44e-10, 1.53e-10, 1.62e-10, 1.71e-10, 1.80e-10, 1.89e-10, 1.98e-10, 2.07e-10, 2.16e-10, 2.25e-10, 2.34e-10, 2.43e-10, 2.52e-10, 2.61e-10, 2.70e-10, 2.78e-10, 2.87e-10 ]
#  levels = [0.0e0, 0.90e-10, 1.80e-10, 2.70e-10, 3.60e-10, 4.50e-10, 5.4e-10, 6.30e-10, 7.20e-10, 8.10e-10, 9.0e-10, 9.9e-10, 1.08e-9, 1.17e-9, 1.26e-9, 1.35e-9, 1.44e-9, 1.53e-9, 1.62e-9, 1.71e-9, 1.80e-9, 1.89e-9, 1.98e-9, 2.07e-9, 2.16e-9, 2.25e-9, 2.34e-9, 2.43e-9, 2.52e-9, 2.61e-9, 2.70e-9, 2.78e-9, 2.87e-9 ]
  patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 84999, 86999, 88999, 90999, 92999, 94999 ,96999 ]
  #levels = [0.0e0, 0.38e-11, 0.76e-11, 1.14e-11, 1.52e-11, 1.90e-11, 2.28e-11, 2.66e-11, 3.04e-11, 3.42e-11, 3.8e-11, 4.18e-11, 4.56e-11, 4.94e-11, 5.32e-11, 5.70e-11, 6.08e-11, 6.46e-11, 6.84e-11, 7.22e-11, 7.6e-11, 7.89e-11, 8.36e-11, 8.74e-11, 9.12e-11, 9.5e-11, 9.88e-11, 1.026e-10, 1.064e-10, 1.102e-10, 1.14e-10, 1.178e-10,  2.8e-10 1.216e-10, 1.254e-10, 1.292e-10, 1.33e-10, 1.368e-10, 1.406e-10, 1.444e-10, 1.482e-10, 1.52e-10, 1.558e-10, 1.596e-10, 1.634e-10, 1.672e-10, 1.81e-10, 1.848e-10, 1.986e-10, 2.8e-10]
  #patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999, 98999]
elsif vname =='Eta'
  levels = [0.0e0, 1.5e-3, 5.0e-3, 8.5e-3, 1.12e-2, 1.55e-2, 1.9e-2, 2.25e-2, 2.6e-2, 2.95e-2, 3.3e-2, 3.65e-2, 4.0e-2, 4.35e-2, 4.7e-2, 5.05e-2, 5.4e-2, 5.75e-2, 6.1e-2, 6.45e-2, 6.8e-2, 7.15e-2, 7.5e-2, 7.85e-2, 8.2e-2, 8.55e-2, 8.9e-2, 9.25e-2, 9.6e-2, 9.95e-2, 1.03e-1, 1.065e-1, 1.11e-1, 1.1135e-1, 1.117e-1]
  #levels = [0.0e0, 1.25e-3, 2.5e-3, 3.75e-3, 5.0e-3, 6.25e-3, 7.5e-3, 8.75e-3, 1.0e-2, 1.125e-2, 1.25e-2, 1.375e-2, 1.5e-2, 1.625e-2, 1.75e-2, 1.875e-2, 2.0e-2, 2.125e-2, 2.25e-2, 2.375e-2, 2.50e-2, 2.625e-2, 2.75e-2, 2.875e-2, 3.0e-2, 3.125e-2, 3.25e-2, 3.375e-2, 3.50e-2, 3.625e-2, 3.750e-2, 3.875e-2]
  #patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 85999, 88999, 91999, 94999, 97999]
  patterns = [0, 10999, 13999, 16999, 19999, 22999, 25999, 28999, 31999, 34999, 37999, 40999, 43999, 46999, 49999, 52999, 55999, 58999, 61999, 64999, 67999, 70999, 73999, 76999, 79999, 82999, 84999, 86999, 88999, 90999, 92999, 94999, 95999, 96999]
elsif vname == 'Press_top'
  levels = [100, 125, 150, 175, 200, 225, 250, 275, 300, 325, 350, 375, 400, 425, 450, 475, 500, 525, 550, 575, 600, 625, 650, 675, 700, 725, 750, 775, 800, 825, 850, 875, 900, 925, 950, 975, 1000, 1025, 1050, 1075, 1100, 1125, 1150, 1175, 1200, 1225, 1250, 1275, 1300, 1325, 1350, 1375, 1400, 1425, 1450, 1475, 1500]
  patterns = [0, 20999, 21999, 22999, 23999, 24999, 25999, 26999, 27999, 28999, 29999, 30999, 31999, 32999, 33999, 34999, 35999, 36999, 37999, 38999, 39999, 40999, 42999, 44999, 46999, 48999, 50999, 52999, 54999, 56999, 58999, 60999, 62999, 64999, 66999, 68999, 70999, 71999, 72999, 73999, 74999, 75999, 76999, 77999, 78999, 79999, 80999, 81999, 82999, 83999, 84999, 85999, 86999, 87999, 88999, 89999, 90999]
elsif vname =='SensB'
  #levels = [-5.0, -4.28, -3.56, -2.84, -2.12, -1.4, -0.68, 0.0e0, 0.72, 1.44, 2.16, 2.88, 3.60, 4.32, 5.04, 5.76, 6.48, 7.20, 7.92, 8.64, 9.36, 10.08, 10.80, 11.52, 12.24, 12.96, 13.68, 14.4, 15.12, 15.84, 16.56, 17]
  levels = [-18.0, -15.43, -12.86, -10.29, -7.72, -5.15, -2.58, 0.0e0, 2.04, 4.08, 6.12, 8.16, 10.2, 12.24, 14.28, 16.32, 18.36, 20.4, 22.44, 24.48, 26.52, 28.56, 30.6, 32.64, 34.68, 36.72, 38.76, 40.8, 42.84, 44.88, 46.92, 48.96]
  patterns = [60999, 61999, 62999, 63999, 64999, 65999, 66999, 75999, 76999, 77999, 78999, 79999, 80999, 81999, 82999, 83999, 84999, 85999, 86999, 87999, 88999, 89999, 90999, 91999, 92999, 93999, 94999, 95999, 96999, 97999, 98999]
end
#if vname == 'KMHF_d' then
#  DCL.sgscmn(34) #Basic-Windspeed
#elsif vname == 'NewmanF_d'
#  DCL.sgscmn(34) #Basic-Windspeed
#elsif vname == 'Tau'
#  DCL.sgscmn(34) #Basic-Windspeed
#elsif vname == 'DDAF_d'
#  DCL.sgscmn(34) #Basic-Windspeed
#elsif vname == 'Sens'
#  DCL.sgscmn(31) #Basic->Temperature
#elsif vname == 'SurfMajCompIce'
#  DCL.sgscmn(27) #Basic->Blues
#end

# 作図

# 地表面との温度差を求める場合
#ggraph_line_difftemp(temp, temp2)
# 時間を直接入力で求める場合
#ggraph_line_lt_input(gphys, gphys2, 52896, 52920,lat,lon,vmax, vmin)
#ggraph_line_lt_input(gphys, gphys2, 60528, 60552,lat,lon,vmax, vmin)

#GGraph.tone(gphys.cut("time"=>lt_array[0]..lt_array[1], "lat"=>lat),true,'lev'=>levels, 'pat'=>patterns,'annotate'=>false)
GGraph.tone(gphys.cut(gphys.axnames[-1]=>lt_array[0]..lt_array[1],"lat"=>lat),true)
#GGraph.set_contour_levels('levels'=>[-14000, -6000, -200, 0.0, 1000, 2000, 4000, 8000, 11000])
GGraph.color_bar
if overwrite_topog_switch
  GGraph.set_contour_levels('levels'=>[0], 'label'=>['0'],'index'=>24)
  #GGraph.set_contour_levels('levels'=>[ -2000, 0.0, 2000,], 'label'=>['-2000','0','2000'])
  GGraph.contour(sp.cut(sp.axnames[-1]=>lt_array[0]..lt_array[1], "lat"=>lat),false,'annotate'=>false)
  GGraph.clear_contour_levels
  GGraph.set_contour_levels('levels'=>[ -2000, 2000,], 'label'=>['-2000','2000'], 'line_type'=>2, 'index'=>1)
  GGraph.contour(sp.cut(sp.axnames[-1]=>lt_array[0]..lt_array[1], "lat"=>lat),false,'annotate'=>false)
end

DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL::grcls
if File.exists?('./sagyou.nc') then
  File.delete('./sagyou.nc')
end
