﻿# coding: utf-8
#
# draw 群の親玉. この中からそれぞれの draw を ruby draw_... で呼び出している. よって, 図示するときはこいつを動かす. 
# 使いたい draw は55 行以下のコメントを外すと使える.
# -y を付けると figs があるときに何も聞かずに削除する. つけないと figs があると削除するか聞く
#
# 使い方
#  ruby draw_ctl
#  ruby draw_ctl -y
#
# 履歴
# 2012-11-10 ファイルの消し方をシェルを使うことにする不満
# 2015-06-11 draw_3D_zm_log_ls_const_ctl.rb を追加
# 2015-10-27 ディレクトリ削除の操作を my_utiles.rbのremake_dir にまとめる
#            draw_2D_localtime_ctl.rb の削除
#            draw_2D_zm_val-t_ctl.rb を draw_2D_fit_lat_zm_val-t_ctl.rb へ
#            draw_2D_x-t_ctl.rb を draw_2D_fit_x-t_with_fit_level_ctl.rbへ
#            以下を追加
#              draw_2D_fit_lat_localtime_val-t_ctl.rb
#              draw_2D_fit_lat_localtime_dda_ctl.rb
#              draw_2D_fit_lat_localtime_frac_ctl.rb
#              draw_2D_fit_lat_localtime_frac_log_ctl.rb
#              draw_2D_fit_lat_localtime_frac_log_overwrite_ctl.rb
#              draw_2D_fit_lat_localtime_log_ctl.rb
#              draw_2D_fit_lat_localtime_log_overwrite_ctl.rb
#              draw_2D_fit_lat_localtime_log_overwrite_wariai_ctl.rb
#              draw_2D_fit_lat_localtime_mean_ctl.rb
#              draw_2D_zm_lat_ls_const_ctl.rb
#              draw_2D_fit_lat_x-t_ctl.rb
#              draw_3D_fit_lat_localtime_z-t_ctl.rb
#              draw_3D_zm_k_per_day-z_individual_overwrite_ctl.rb
#              draw_3D_zm_k_per_day-log_individual_overwrite_ctl.rb
# 2015/11/04 draw_2D_localtime_mean_xy_ctl.rb を追加
#
# ===========
#
#-----作業ディレクトリ作成-------
#
$LOAD_PATH.push(Dir.pwd)
require 'my_utils'
require 'optparse' #オプションを受け付けるようにする
#
#
#============ 時間測定用変数代入 ============
# 変更しないこと
t0 = Time.now
t2 = Process.times
#============= オプション判定 =======================
# 変更しないこと
figdir = 'figs'
#figfile = Dir[ File.expand_path(figdir)+"/*"] #ディレクトリ内のファイルを絶対パスで受け取る
OptionParser.new do |opt| #オプションを受け取る
 remake_dir(figdir, opt) 
end
#figdirがある時は削除するかを聞く. オプション-yをつけると宣告なしで削除する
#===========================================
#--------------実行文----------------------
#ここ以下で使いたいスクリプトのコメントアウトを外すとその絵を描ける.
#
#
# ------------2 次元量--------------
# Ls=30 度毎に平均した地表面緯度経度図
p 'xy'
system( 'ruby draw_2D_xy_ctl.rb' )
#### Ls=30 度毎に平均した東西平均緯度グラフ 
###p "==============================================="
###p "================================================="
###p 'zm_y'
###system( 'ruby draw_2D_zm_y_ctl.rb' )
#
# 東西平均した緯度-Ls 図. 地表面データの図.
p "==============================================="
p "================================================="
p '2D-time'
system( 'ruby draw_2D_zm_t_ctl.rb' )
#
## 地表面緯度経度図のスナップショット (ローカルタイム) のアニメーション.
#p "==============================================="
#p "================================================="
#p 'lt'
#system( 'ruby draw_2D_lt_ctl.rb' )
#
## 地表面データの全球平均量.
#p "==============================================="
#p "================================================="
#p 'Global mean 2Dval-t'
#system( 'ruby draw_2D_val-t_ctl.rb' )
#
## 地表面データの Ls を固定した (Ls=5度程度で平均した) 緯度経度図.
#p "==============================================="
#p "================================================="
#p 'lsconst2d'
#system( 'ruby draw_2D_xyls_ctl.rb' )
#
## 緯度と経度を固定した巻き上げの一日における回数
#p "==============================================="
#p "================================================="
#p 't-n'
#system( 'ruby draw_2D_t-n_ctl.rb')
#
## 指定した時間 + 10 日平均した東西平均緯度分布
#p "==============================================="
#p "================================================="
#p '2D-zonal mean val-lat'
#system( 'ruby draw_2D_zm_val-lat_ctl.rb')
#
## 東西平均, Ls を決め打ちして時間平均した緯度分布
#p "==============================================="
#p "================================================="
#p '2D zonal mean_time mean_with_fiting_Ls_val-lat'
#system( 'ruby draw_2D_zm_lat_ls_const_ctl.rb' )
#
## 二次元データ - 平均データ のホフメラーダイアグラム.
##p "==============================================="
##p "================================================="
##p 'disturbx-t'
##system( 'ruby draw_2D_distur_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイム
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_val-t'
#system( 'ruby draw_2D_fit_lat_localtime_val-t_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイム
## 確認用に sens と eta から dda を計算し, 元のdda と一緒に重ね書きする
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_dda-t'
#system( 'ruby draw_2D_fit_lat_localtime_dda_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイム
## 二つの変数を割ったものを描く
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_frac-t'
#system( 'ruby draw_2D_fit_lat_localtime_frac_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイム
## 割ったものをさらにログを取る
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_frac_log-t'
#system( 'ruby draw_2D_fit_lat_localtime_frac_log_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイム
## 割ってログを取ったものを重ね書きする
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_frac_log-t_overwrite'
#system( 'ruby draw_2D_fit_lat_localtime_frac_log_overwrite_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイムを対数化する
## そうすることで掛け合わせの相関を見てみる
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_log-t'
#system( 'ruby draw_2D_fit_lat_localtime_log_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイムを対数化する
## そうすることで掛け合わせの相関を見てみる
## 更にsens eta dda を重ね書きする
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_log-t_overwrite'
#system( 'ruby draw_2D_fit_lat_localtime_log_overwrite_ctl.rb')
#
## 2次元変数の緯度経度固定Ls固定のローカルタイムを対数化する
## そうすることで掛け合わせの相関を見てみる
## 対数化した dir と dir2 のものを引き合わせたものを描く
## そうすることで log(dir/dir2) を見る
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_log-t_overwrite_wariai'
#system( 'ruby draw_2D_fit_lat_localtime_log_overwrite_wariai_ctl.rb')
#
## 2次元変数の緯度固定Ls指定してローカルタイムに沿った時間平均した図 (var-lon)
## mknc_dm1lst にも対応. localtime_mean にも対応.
#p "==============================================="
#p "================================================="
#p 'fit_lat_localtime_mean'
#system( 'ruby draw_2D_fit_lat_localtime_mean_ctl.rb')
#
## 2次元変数の緯度固定 10 日間分平均した東西平均量
#p "==============================================="
#p "================================================="
#p 'fit_lat_zm_val-t'
#system( 'ruby draw_2D_fit_lat_zm_val-t_ctl.rb')
#
## 2次元変数の緯度固定Ls指定したホフメラーダイアグラム (lon-time)
## mknc_dm1lst にも対応. その場合は縦軸は Ls になる
#p "==============================================="
#p "================================================="
#p 'fit_lat_x-t'
#system( 'ruby draw_2D_fit_x-t_ctl.rb' )
#
## 地表面データの時間経度図 (ホフメラーダイアグラム)
## 左に Ls, 右に hour を書く
## 3D データも指定可能
#p "==============================================="
#p "================================================="
#p 'fit_lat_x-t_with_level'
#system( 'ruby draw_2D_fit_x-t_with_fit_level_ctl.rb' )
#
## Ls 指定したローカル地無に沿って時間平均した緯度経度断面 (lat-lon)
#p "==============================================="
#p "================================================="
#p 'localtime mean lat-lon'
#system( 'ruby draw_2D_localtime_mean_xy_ctl.rb' )
#
#--------3次元量------------
#
## Ls=30 度平均した東西平均緯度高度断面図 (鉛直方向は気圧座標で対数表示)
#p "==============================================="
#p "================================================="
#p '3D-log'
#system( 'ruby draw_3D_zm_log_ctl.rb' )
#
## 指定した Ls で平均した東西平均緯度高度断面 (level-lat)
## K/s のデータは K/day に変換して計算する 
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut'
# 
#system( 'ruby draw_3D_zm_log_ls_const_ctl.rb')
#
## 指定したLs間で平均した東西平均緯度高度断面 (sigma-lat)
## K/s のデータは K/day に変換して計算する 
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, sigma-lat'
# 
#system( 'ruby draw_3D_zm_ls_const_ctl.rb')
#
## 3次元データを指定した Ls で平均し, 指定した緯度での
## 東西平均鉛直プロファイル(K/day-sig)を書く
## K/s のデータは K/day に変換して計算する 
## 全て一つの画像に重ね書く
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, latitude const. sig-var'
# 
#system( 'ruby draw_3D_zm_k_per_day-z_ctl.rb')
#
## 3次元データを指定した Ls で平均し, 指定した緯度での
## 東西平均鉛直プロファイル(K/day-sig)を書く
## K/s のデータは K/day に変換して計算する 
## 一つ一つの画像を書く
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, latitude const, individual. sig-var'
# 
#system( 'ruby draw_3D_zm_k_per_day-z_individual_ctl.rb')
#
# 東西平均, Ls を決め打ちして時間平均した加熱率の鉛直プロファイル(σ座標) ディレクトリで指定したものを重ね書く(K/day - sig)
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, latitude const, individual overwrite. sig-var'
# 
#system( 'ruby draw_3D_zm_k_per_day-z_individual_overwrite_ctl.rb')
## 3次元データを指定した Ls で平均し, 指定した緯度での
## 東西平均鉛直プロファイル(K/day-level)を書く
## K/s のデータは K/day に変換して計算する 
## 全て一つの画像に重ね書く
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, latitude const. level-var'
# 
#system( 'ruby draw_3D_zm_k_per_day-log_ctl.rb')
#
## 3次元データを指定した Ls で平均し, 指定した緯度での
## 東西平均鉛直プロファイル(K/day-level)を書く
## K/s のデータは K/day に変換して計算する 
## 一つ一つの画像を書く
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, latitude const, individual. level-var'
# 
#system( 'ruby draw_3D_zm_k_per_day-log_individual_ctl.rb')
#
# 東西平均, Ls を決め打ちして時間平均した加熱率の鉛直プロファイル(圧力座標) ディレクトリで指定したものを重ね書く(K/day - level)
#p "==============================================="
#p "================================================="
#p '3D-zonal mean for ls_cut, latitude const, individual, overwrite. level-var'
# 
#system( 'ruby draw_3D_zm_k_per_day-log_individual_overwrite_ctl.rb')
#
## σ座標での東西平均季節平均子午面図
#p "==============================================="
#p "================================================="
#p '3D-z'
#system( 'ruby draw_3D_zm_z_ctl.rb' )
#
## 東西平均した緯度-Ls 図. 3次元データの高度固定した図.
#p "==============================================="
#p "================================================="
#p '3D-time'
#system( 'ruby draw_3D_zm_t_ctl.rb' )
#
## 東西平均した緯度-Ls 図. 3次元データの高度を重み付平均した図.
#p "==============================================="
#p "================================================="
#p '3D-vm-time'
#system( 'ruby draw_3D_vm_zm_t_ctl.rb' )
#
# 3次元変数の緯度経度固定Ls固定の高さ-ローカルタイム断面図
#p "==============================================="
#p "================================================="
#p '3D-fit_lat_fit_lon_localtime_z-t'
#system( 'ruby draw_3D_fit_lat_localtime_z-t_ctl.rb' )
#
### 高度を固定した3次元量の緯度経度図のスナップショット (ローカルタイム) のアニメーション.
##p "==============================================="
##p "================================================="
##p 'const level lt3d'
##system( 'ruby draw_3D_level_lt_ctl.rb' )
#
## 3次元データの全球平均量. 
#p "=================================================="
#p "=================================================="
#p 'Global mean 3D val-time'
#system('ruby draw_3D_val-t_ctl.rb')
#
## 指定した時間 + 10 日平均した東西平均緯度分布
#p "==============================================="
#p "================================================="
#p '3D-zonal mean-val'
#system( 'ruby draw_3D_zm-val_ctl.rb')
#
### 3次元データの Ls を固定 (Ls=5度程度で平均した) 東西平均緯度高度断面.
##p "==============================================="
##p "================================================="
##p 'lsconst3d'
##system( 'ruby draw_3D_zm_ls_ctl.rb' )
#
### 3次元データの高度を固定したLs を固定した緯度経度図
##p "==============================================="
##p "================================================="
##p 'lsconst2d-altconst'
##system( 'ruby draw_3D_xyls_ctl.rb' )
#
### 3次元データの高度-Ls断面.
##p "==============================================="
##p "================================================="
##p 'z-t'
##system( 'ruby draw_3D_z-t_ctl.rb' )
#
### 3次元データの高度を固定したLs=30度で平均した緯度経度断面.
##p "==============================================="
##p "================================================="
##p '3Dxy'
##system( 'ruby draw_3D_xymonmean_ctl.rb')
#
# --------鉛直一次元-----------
#
## 一次元データ(lat,time)のLs変化図
#p "=================================================="
#p "=================================================="
#p '1Dtime'
#system('ruby draw_1D_t_ctl.rb')
#
## 一次元データ(lat,time)のローカルタイム
#p "=================================================="
#p "=================================================="
#p '1Dlocaltime'
#system('ruby draw_1D_localtime_ctl.rb')
#
## 二次元データ(lat,z,time)のLs変化図
#p "=================================================="
#p "=================================================="
#p '1Dz-t'
#system('ruby draw_1D_z-t_ctl.rb')
#
## 二次元データ(lat,z,time)のローカルタイム図
#p "=================================================="
#p "=================================================="
#p '1Dz-localtime'
#system('ruby draw_1D_z-localtime_ctl.rb')
#
## 二次元データ(lat,z,time)の対数—ローカルタイム
#p "=================================================="
#p "=================================================="
#p '1Dlog-localtime'
#system('ruby draw_1D_log-localtime_ctl.rb')
#
## 二次元データ(lat,z,time)の対数-Ls図
#p "=================================================="
#p "=================================================="
#p '1Dlog-time'
#system('ruby draw_1D_log-t_ctl.rb')
#
## 一次元データ(lat,time)の緯度加重平均の時間変化.
#p "=================================================="
#p "=================================================="
#p '1Dval-time'
#system('ruby draw_1D_val-t_ctl.rb')
#
#-------他--------
## 地表特性図.
#p "==============================================="
#p "================================================="
#p 'sp'
#system( 'ruby draw_sp_ctl.rb')
## 全球平均 OLRA, OSRA, SLRA,SSRA, の雨なしのデータ出力
#p "==============================================="
#p "================================================="
#p 'global mean sens, olr, osr, ssr, slr'
#system( 'ruby draw_gm_not_Rain.rb')
#=============== 実行分終了 =======================

#=============== 時間測定出力 =====================
t1 = Time.now
t3 = Process.times

puts "real time is #{t1 - t0} sec"
puts "real time with minute is #{(t1 - t0)/60.0} min"
puts "user time is #{t2.utime - t3.utime} sec"
puts "subuser time is #{t2.cutime - t3.cutime} sec"
puts "subprocess time is #{t2.cstime - t3.cstime} sec"
