﻿# -*- coding: utf-8 -*-
#
#
#2012/11/22 x-tを追加ver1.1
#2012/11/29 x-tを変更月ごとの図にすることにするver1.2
#2012/12/10 lt の3d版追加, x-tを一日平均せず時間ごとの図にするver1.3
#2012/12/11 dcpam_time_divid を追加ver1.4
#2012/12/18 Ls のロングネームを変更するver1.4
#2013/01/06 Ls表示にするルーチンでなぜかcut("Ls"=>180)Ls=180以下が全て"Ls"=>0になってしまうので対処として90だけ直接書いたver1.5
#2013/12/15 maketimeで一年分無くても途中で動くようにするver1.6
#2014/07/29 dcpam_time_2D を追加ver1.6
#2014/09/30 dcpam_global_mean_3D を追加ver1.7
#2014/10/06 zonal_mean_3D_with_layer, zonal_mean_3D_with_value を追加 ver1.8
#2015/08/07 local_starting_time_and_ending_time を追加. また, my_utils を読み込むようにする ver1.9
#2015/09/18 荻原 ls_to_time を gphys_time から移動. 軸 Ls の変数時間の nc ファイルを作成 gphys_time_v1.10
# 2015/10/20 荻原 ls_to_time と local_starting_time_and_ending_time を更新. time の単位が sec にも対応 gphys_time_v1.11
# 2015/11/11 荻原 dcpam_hours を変更 sec にも対応 gphys_time_v1.12
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require 'my_utils'
require "numru/ggraph"
include NumRu
include NMath

#########################################################################################
def maketime ( dir, iyrs, iyre, gphys )

  ls = GPhys::IO.open('../PlanetLonFromVE.nc',"PlanetLonFromVE")
  #  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  if (gphys.coord("time")[-1].val[0]) < te then
    te = gphys.coord("time")[-1].val[0]
    days = (gphys.coord("time")[-1].val[0])/24
  end
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(days)

  for i in 0..(days -1)
    ls[i] = lscut[(i * 24)..(i * 24 + 23)].mean(0).val
  end


  ls.length
  gphyscut = gphys.cut("time"=>ts..te) 


  sagyoufile = NetCDF.create('sagyou.nc')
  gphyscut.axnames.each do |dim|
    if dim != "time" then
      sagyoufile.def_dim(dim, gphyscut.coord(dim).length)
    else
      sagyoufile.def_dim('Ls', ls.size)
    end
  end
  #軸定義
  gphyscut.axnames.each do |dim|
    sagyoufile.redef
    if dim != "time" then
      sagyou = sagyoufile.def_var(dim, gphyscut.coord(dim).ntype, [gphyscut.coord(dim).name])
      #属性定義
      for i in 0..gphyscut.coord(dim).att_names.size - 1
        sagyou.put_att(gphyscut.coord(dim).att_names[i], gphyscut.coord(dim).get_att(gphyscut.coord(dim).att_names[i]))
      end
      sagyoufile.enddef
      sagyou.put(gphyscut.coord(dim).val)
    else
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
      sagyoufile.enddef
    end
  end
  # 変数定義
  array = Array.new(gphyscut.shape.length)
  array = gphyscut.axnames
  array[-1] = 'Ls'
  sagyoufile.redef
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  time = sagyoufile.var('Ls')
  array1 = Array.new(gphyscut.axnames.length - 1,0)
  array2 = Array.new(gphyscut.axnames.length - 1,0)
  ls.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    sagyou.put(gphyscut[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime
end

######################################################################
########

def dcpam_hours(iyrs, iyre, lt, unit='hour', method='month')
  #月の初めの時間を要素1に月の終わりの時間を要素2に入れる(それぞれの要素は入力ltの配列であらわされる)
  # unit = hour の場合計算するときの時間の単位が hour
  # unit = sec の場合 計算するときの時間の単位が sec
  # method = month にすると lt に与えられた月すべて計算
  # method = appointed にすると lt =[[Ls_start, Ls_end], [Ls2_start, Ls2_end],...,[Lsn_start, Lsn_end]]で与えられた Lsの指定に合わせて Ls_start から Ls_end までの間で計算し, hours = [ts,te]で返す. ts = [Ls_start_to_time, Ls2_start_to_time,...,Lsn_start_to_time], te = [Ls_end_to_time, Ls2_end_to_time,...,Lsn_end_to_time] である.
  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  if method == 'month'
    if unit == 'hour'
      tsyear = (iyrs - 1) * daysOfYear * DataNumOfDay
      ts = Array.new(lt.size,tsyear)
      te = Array.new(lt.size,tsyear + DaysOfMonth[0] * DataNumOfDay)
      for i in 0..lt.size-1
        for mon in 0..(lt[i] - 2)
          if lt[i] - 2 <= 0 then
            ts[i] = 0
          else
            ts[i] = ts[i] + DaysOfMonth[mon] * DataNumOfDay
          end
          te[i] = te[i] + DaysOfMonth[mon+1] * DataNumOfDay
        end
      end
    elsif unit == 'sec'
      tsyear = (iyrs - 1) * daysOfYear * DataNumOfDay * HoursOfSecond
      ts = Array.new(lt.size,tsyear)
      te = Array.new(lt.size,tsyear + DaysOfMonth[0] * DataNumOfDay* HoursOfSecond)
      for i in 0..lt.size-1
        for mon in 0..(lt[i] - 2)
          if lt[i] - 2 <= 0 then
            ts[i] = 0
          else
            ts[i] = ts[i] + DaysOfMonth[mon] * DataNumOfDay * HoursOfSecond
          end
          te[i] = te[i] + DaysOfMonth[mon+1] * DataNumOfDay * HoursOfSecond
        end
      end
    end
  elsif method == 'appointed'
    ts = Array.new(lt.size)
    te = Array.new(lt.size)
    lt.each_with_index do |lt_array,index|
      ts[index] = lt_array[0]
      te[index] = lt_array[1]
    end
  end
  hours = [ts,te]
  return hours
end

def dcpam_time_divid(iyrs, iyre, divid, lt)
  #月ごとの時間をdividの要素に合わせてわけた配列を返す
  hours = dcpam_hours(iyrs, iyre, lt)
  divsize = Array.new(lt.length)
  for imon in 0..(lt.length - 1)
    tmp1 = (hours[1][imon] - hours[0][imon] + divid[0] + 1).divmod(divid[1])
    if tmp1[1] == 0 then
      tmp2 = Array.new(tmp1[0]+1)
      tmp2[0] = hours[0][imon] + divid[0]
      for div in 1..(tmp2.length - 1)
        tmp2[div] = tmp2[div - 1] + divid[1] - 1
      end  
    else
      tmp2 = Array.new(tmp1[0] + 2)
      tmp2[0] = hours[0][imon] + divid[0]
      for div in 1..(tmp2.length - 1)
        tmp2[div] = tmp2[div - 1] + divid[1] - 1
      end
      tmp2[-1] = hours[1][imon]
    end
    divsize[imon] = tmp2
  end
  return divsize
end

def dcpam_lt( hour, gphys)
  #2D, のスナップショットを取り出す

  gphyscut = gphys.cut("time"=>hour)
  return gphyscut
end

def dcpam_lt3d( hour, lev, gphys)
  #3Dの hour 時間, 高度 lev のスナップショットを切り出す

  gphyscut = gphys.cut("time"=>hour, "level"=>lev)
  return gphyscut
end

def dcpam_x_t2d ( dir, hourss, hourse, iyrs, iyre, lat, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  lscut = ls.cut("time"=>hourss..hourse)

  gphyscut = gphys.cut("lat"=>lat,"time"=>hourss..hourse) 

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  lscut.val.each do |times|
    sagyou.put(gphyscut[false, index].val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end
def dcpam_x_t3d ( dir, hourss, hourse, iyrs, iyre, lat, alt, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  lscut = ls.cut("time"=>hourss..hourse)

  gphyscut = gphys.cut("lat"=>lat, "level"=>alt, "time"=>hourss..hourse) 


  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  lscut.val.each do |times|
    sagyou.put(gphyscut[false,index].val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end

def dcpam_x_t2d_daymean ( dir, hourss, hourse, iyrs, iyre, lat, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end
  dayss = 0
  for days in 0..hourss-2 
    dayss += DaysOfMonth[days]
  end
  dayse = 0
  for days in 0..hourse-1
    dayse += DaysOfMonth[days]
  end
  ts = (iyrs - 1) * daysOfYear * DataNumOfDay + dayss * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay + dayse * DataNumOfDay
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(dayse - dayss)

  for i in 0..(dayse - dayss - 1)
    ls[i] = lscut[(i * 24)..(i * 24 +23)].mean(0).val
  end


  gphyscut = gphys.cut("lat"=>lat,"time"=>ts..te) 


  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', ls.size)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  ls.each do |times|
    sagyou.put(gphyscut[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end
def dcpam_x_t3d_daymean ( dir, hourss, hourse, iyrs, iyre, lat, alt, gphys )

  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lon = gphys.coord("lon")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  dayss = 0
  for days in 0..hourss-2 
    dayss += DaysOfMonth[days]
  end
  dayse = 0
  for days in 0..hourse-1
    dayse += DaysOfMonth[days]
  end
  ts = (iyrs - 1) * daysOfYear * DataNumOfDay + dayss * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay + dayse * DataNumOfDay
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(dayse - dayss)

  for i in 0..(dayse - dayss - 1)
    ls[i] = lscut[(i * 24)..(i * 24 +23)].mean(0).val
  end

  gphyscut = gphys.cut("lat"=>lat, "level"=>alt, "time"=>ts..te) 


  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(lon.name, lon.length)
  sagyoufile.def_dim('Ls', ls.size)
  #軸定義
  sagyou = sagyoufile.def_var(lon.name, lon.ntype, [lon.name])
  #属性定義
  for i in 0..lon.att_names.size - 1
    sagyou.put_att(lon.att_names[i], lon.get_att(lon.att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(lon.val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[lon.name,'Ls'])
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  ls.each do |times|
    sagyou.put(gphyscut[false, (index * 24)..(index * 24 + 23)].mean(-1).val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end

def dcpam_SurfMaj ( dir, iyrs, iyre ) 
  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay

  lscut = ls.cut("time"=>ts..te)

  gphys = GPhys::IO.open(dir+'/'+'SurfMajCompIce.nc','SurfMajCompIce')
  gphyscut = gphys.cut("time"=>ts..te) 

  sagyoufile = NetCDF.create('sagyou2.nc')
  for i in 0..gphys.shape.size-2
    sagyoufile.def_dim(gphys.coord(i).name, gphys.coord(i).length)
  end
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  for i in 0..gphys.shape.size-2
    sagyou = sagyoufile.def_var(gphys.coord(i).name, gphys.coord(i).ntype, [gphys.coord(i).name])
    #属性定義
    for j in 0..gphys.coord(i).att_names.size - 1
      sagyou.put_att(gphys.coord(i).att_names[j], gphys.coord(i).get_att(gphys.coord(i).att_names[j]))
    end
    sagyoufile.enddef
    sagyou.put(gphys.coord(i).val)
    sagyoufile.redef
  end
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  array = Array.new(gphys.shape.size)
  for i in 0..array.size-2
    array[i] = gphys.coord(i).name
  end
  array[-1] = 'Ls'
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  array1 = Array.new(gphys.shape.size-1,0)
  array2 = Array.new(gphys.shape.size-1,0)
  lscut.val.each do |times|
    array1.fill(0,0..gphys.shape.size-2).push(index)
    array2.fill(-1,0..gphys.shape.size-2).push(index)
    sagyou.put(gphyscut[false,index].val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close
end

def dcpam_ls ( dir, iyrs, iyre, gphysfile, gphys ) 
  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay

  lscut = ls.cut("time"=>ts..te)

  gphyscut = gphys.cut("time"=>ts..te) 

  sagyoufile = NetCDF.create('sagyou.nc')
  gphysfile.each_dim do |dim|
    if dim.name == "time" then
      sagyoufile.def_dim('Ls', lscut.length)
    else
      sagyoufile.def_dim(dim.name, dim.length_ul0)
    end
  end
  gphysfile.each_var do |var|
    sagyoufile.redef
    if var.name == "time" then
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
    elsif var.name == gphys.name then
      array = Array.new(gphys.shape.size)
      for i in 0..array.size-2
        array[i] = gphys.coord(i).name
      end
      array[-1] = 'Ls'
      sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
      for i in 0..var.att_names.size - 1
        sagyou.put_att(var.att(var.att_names[i]).name, var.att(var.att_names[i]).get)
      end
      sagyoufile.enddef
      timevar = sagyoufile.var('Ls')
      index = 0
      array1 = Array.new(gphys.shape.size-1,0)
      array2 = Array.new(gphys.shape.size-1,0)
      lscut.val.each do |times|
        array1.fill(0,0..gphys.shape.size-2).push(index)
        array2.fill(-1,0..gphys.shape.size-2).push(index)
        sagyou.put(gphyscut[false,index].val, "start"=>array1, "end"=>array2)
        timevar.put(times, "index"=>[index])
        array1.delete_at(-1)
        array2.delete_at(-1)
        index = index + 1
      end
    else
      sagyouvar = sagyoufile.def_var(var.name, var.vartype, var.dims)
      for i in 0..var.att_names.size - 1
        sagyouvar.put_att(var.att(var.att_names[i]).name, var.att(var.att_names[i]).get)
      end
      sagyoufile.enddef
      sagyouvar.put(var.get)
    end
  end
  sagyoufile.close
end

def dcpam_ls3d ( dir, iyrs, iyre, lstime, gphys ) 
  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay

  lscut = ls.cut("time"=>ts..te)

  gphyscut = gphys.cut("time"=>ts..te) 


  sagyoufile = NetCDF.create('sagyou.nc')
  for i in 0..gphys.shape.size-2
    sagyoufile.def_dim(gphys.coord(i).name, gphys.coord(i).length)
  end
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  for i in 0..gphys.shape.size-2
    sagyou = sagyoufile.def_var(gphys.coord(i).name, gphys.coord(i).ntype, [gphys.coord(i).name])
    #属性定義
    for j in 0..gphys.coord(i).att_names.size - 1
      sagyou.put_att(gphys.coord(i).att_names[j], gphys.coord(i).get_att(gphys.coord(i).att_names[j]))
    end
    sagyoufile.enddef
    sagyou.put(gphys.coord(i).val)
    sagyoufile.redef
  end
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  array = Array.new(gphys.shape.size)
  for i in 0..array.size-2
    array[i] = gphys.coord(i).name
  end
  array[-1] = 'Ls'
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  array1 = Array.new(gphys.shape.size-1,0)
  array2 = Array.new(gphys.shape.size-1,0)
  lscut.val.each do |times|
    array1.fill(0,0..gphys.shape.size-2).push(index)
    array2.fill(-1,0..gphys.shape.size-2).push(index)
    sagyou.put(gphyscut[false,index].val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close

  gphysls = GPhys::IO.open("sagyou.nc", gphys.name)
  if lstime == 90 then
    gphyslscut = gphysls[false,4642]
  else 
    gphyslscut = gphysls.cut("Ls"=>lstime)
  end
  return gphyslscut
end
def dcpam_z_t3d ( dir, hourss, hourse, iyrs, iyre, lat, lonswitch, lon, gphys )

  ls = GPhys::IO.open('../'+"PlanetLonFromVE.nc","PlanetLonFromVE")

  lscut = ls.cut("time"=>hourss..hourse)

  if lonswitch then
    gphyscut = gphys.cut("lat"=>lat, "time"=>hourss..hourse).mean(0)
  else
    gphyscut = gphys.cut("lat"=>lon, "lat"=>lat, "time"=>hourss..hourse)
  end

  sagyoufile = NetCDF.create('sagyou.nc')
  sagyoufile.def_dim(gphys.coord("level").name, gphys.coord("level").length)
  sagyoufile.def_dim('Ls', lscut.length)
  #軸定義
  sagyou = sagyoufile.def_var(gphys.coord("level").name, gphys.coord("level").ntype, [gphys.coord("level").name])
  #属性定義
  for i in 0..gphys.coord("level").att_names.size - 1
    sagyou.put_att(gphys.coord("level").att_names[i], gphys.coord("level").get_att(gphys.coord("level").att_names[i]))
  end
  sagyoufile.enddef
  sagyou.put(gphys.coord("level").val)
  sagyoufile.redef
  time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
  time.put_att(lscut.att_names[0], 'planetary longitude')
  for i in 1..lscut.att_names.size-1
    time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
  end
  # 変数定義
  sagyou =  sagyoufile.def_var(gphys.name, gphys.ntype,[gphys.coord("level").name,'Ls'])
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  lscut.val.each do |times|
    sagyou.put(gphyscut[false,index].val, "start"=>[0,index], "end"=>[-1,index])
    time.put(times, "index"=>[index])
    index = index + 1
  end
  sagyoufile.close 
  gphysxt = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphysxt
end
def time_dis(iyrs, iyre, divid, lt)
  #月ごとの時間をdividの要素に合わせてわけた配列を返す
  hours = dcpam_hours(iyrs, iyre, lt)
  divsize = Array.new(lt.length)
  for imon in 0..(lt.length - 1)
    tmp1 = (hours[1][imon] - hours[0][imon] + divid[0] + 1).divmod(divid[1])
    tmp2 = Array.new(tmp1[0]+1)
    tmp2[0] = hours[0][imon] + divid[0]
    for div in 1..(tmp2.length - 1)
      tmp2[div] = tmp2[div - 1] + divid[1] - 1
    end  
    divsize[imon] = tmp2
    #    divsize[imon,1] = tmp1[0]
  end
  return divsize
end
def dcpam_time_num(hourss, hourse, lat, lon, pat, timenum, gphys)
  localt=(lon-180)/15
  hourss = hourss + localt
  hourse = hourse + localt
  gphyscut = gphys.cut("lon"=>lon, "lat"=>lat, "time"=>hourss..hourse)
  for time in 0..24
    if gphyscut[false, time].val[0] >= pat then
      timenum[time] += 1
    end
  end  
  return timenum
end
def dcpam_time_1D(hourss, hourse, lon, gphys)
  #localt = ((lon - 100)/15).to_i + 12
  localt = 0
  #  localt=(lon-180)/15.to_i + 12
  p localt
  hourss = hourss + localt
  hourse = hourse + localt
  gphyscut = gphys[0,0,false].cut("time"=>hourss..hourse)
  return gphyscut
end
def dcpam_time_2D(hourss, hourse, lat, lon, gphys)
  #localtimeを常に0時から始めるように設定
  localt = (lon/15).to_i
  #  localt=(lon-180)/15.to_i + 12
  p localt
  if hourss -localt > gphys.coord("time").val[0] then
    hourss = hourss - localt
    hourse = hourse - localt
  end
  gphyscut = gphys.cut("lon"=>lon, "lat"=>lat, "time"=>hourss..hourse)
  return gphyscut
end
def dcpam_global_mean_3D( dir, iyrs, iyre, vname, gphys )

  ls = GPhys::IO.open('../PlanetLonFromVE.nc',"PlanetLonFromVE")
  ps = GPhys::IO.open('../Ps.nc', 'Ps')
  #  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  if (gphys.coord("time")[-1].val[0]) < te then
    te = gphys.coord("time")[-1].val[0]
    days = (gphys.coord("time")[-1].val[0])/24
  end
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(days)

  for i in 0..(days -1)
    ls[i] = lscut[(i * 24)..(i * 24 + 23)].mean(0).val
  end


  ls.length
  gphyscut = gphys.cut("time"=>ts..te) 

  # 全球平均のための緯度重み

  #cos_phi = (gphys.axis("lat").to_gphys * (PI/180.0)).cos
  #fact = cos_phi / cos_phi.mean
  lat_weight = GPhys::IO.open(dir+'/'+vname+'.nc', 'lat_weight')

  # 高度重み
  sig_weight = GPhys::IO.open(dir+'/'+vname+".nc", 'sig_weight')

  sagyoufile = NetCDF.create('sagyou.nc')
  gphyscut.axnames.each do |dim|
    if dim != "time" then
      sagyoufile.def_dim(dim, gphyscut.coord(dim).length)
    else
      sagyoufile.def_dim('Ls', ls.size)
    end
  end
  #軸定義
  gphyscut.axnames.each do |dim|
    sagyoufile.redef
    if dim != "time" then
      sagyou = sagyoufile.def_var(dim, gphyscut.coord(dim).ntype, [gphyscut.coord(dim).name])
      #属性定義
      for i in 0..gphyscut.coord(dim).att_names.size - 1
        sagyou.put_att(gphyscut.coord(dim).att_names[i], gphyscut.coord(dim).get_att(gphyscut.coord(dim).att_names[i]))
      end
      sagyoufile.enddef
      sagyou.put(gphyscut.coord(dim).val)
    else
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
      sagyoufile.enddef
    end
  end
  # 変数定義
  array = Array.new(1)
  array[-1] = 'Ls'
  sagyoufile.redef
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  time = sagyoufile.var('Ls')
  array1 = Array.new(0,0)
  array2 = Array.new(0,0)
  ls.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    #sagyou.put((((gphyscut[false, (index * 24)..(index * 24 + 23)] * fact).mean(0,1)*sig_weight).sum('sig')/sig_weight.sum).mean('time').val, "start"=>array1, "end"=>array2)
    #sagyou.put(((((((gphyscut[false, (index * 24)..(index * 24 + 23)]  * ps[false,(index*24)..(index * 24 + 23)])*lat_weight).sum('lat')) * sig_weight).sum('sig'))/(Grav * lat_weight.sum * sig_weight.sum)).mean('lon','time').val, "start"=>array1, "end"=>array2)
    sagyou.put(((((((gphyscut[false, (index * 24)..(index * 24 + 23)]  * ps[false,(index*24)..(index * 24 + 23)])*lat_weight).sum('lat')) * sig_weight).sum('sig'))/((((ps[false, (index*24)..(index*24 + 23)] * lat_weight).sum('lat')) * sig_weight.sum))).mean('lon','time').val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime
end

def dcpam_zonal_mean_virtical_mean ( dir, iyrs, iyre, vname, gphys )

  ls = GPhys::IO.open('../PlanetLonFromVE.nc',"PlanetLonFromVE")
  #  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  if (gphys.coord("time")[-1].val[0]) < te then
    te = gphys.coord("time")[-1].val[0]
    days = (gphys.coord("time")[-1].val[0])/24
  end
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(days)

  for i in 0..(days -1)
    ls[i] = lscut[(i * 24)..(i * 24 + 23)].mean(0).val
  end


  gphyscut = gphys.cut("time"=>ts..te) 

  # 高度重み
  sig_weight = GPhys::IO.open(dir+'/'+vname+".nc", 'sig_weight')


  sagyoufile = NetCDF.create('sagyou.nc')
  gphyscut.axnames.each do |dim|
    if dim != "time" then
      sagyoufile.def_dim(dim, gphyscut.coord(dim).length)
    else
      sagyoufile.def_dim('Ls', ls.size)
    end
  end
  #軸定義
  gphyscut.axnames.each do |dim|
    sagyoufile.redef
    if dim != "time" then
      sagyou = sagyoufile.def_var(dim, gphyscut.coord(dim).ntype, [gphyscut.coord(dim).name])
      #属性定義
      for i in 0..gphyscut.coord(dim).att_names.size - 1
        sagyou.put_att(gphyscut.coord(dim).att_names[i], gphyscut.coord(dim).get_att(gphyscut.coord(dim).att_names[i]))
      end
      sagyoufile.enddef
      sagyou.put(gphyscut.coord(dim).val)
    else
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
      sagyoufile.enddef
    end
  end
  # 変数定義
  #  array = Array.new(gphyscut.shape.length -2)
  array = ['lat','Ls']
  sagyoufile.redef
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  time = sagyoufile.var('Ls')
  array1 = Array.new(gphyscut.axnames.length - 3,0)
  array2 = Array.new(gphyscut.axnames.length - 3,0)
  ls.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    sagyou.put(((gphyscut[false, (index * 24)..(index * 24 + 23)] *sig_weight).sum('sig')/sig_weight.sum).mean(0,-1).val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime
end

def zonal_mean_3D_with_layer ( dir, iyrs, iyre, layer, gphys )
  # 高度を層番号で指定した東西平均した nc ファイルを返す. 時間軸は Ls にする

  ls = GPhys::IO.open('../PlanetLonFromVE.nc',"PlanetLonFromVE")
  #  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  if (gphys.coord("time")[-1].val[0]) < te then
    te = gphys.coord("time")[-1].val[0]
    days = (gphys.coord("time")[-1].val[0])/24
  end
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(days)

  for i in 0..(days -1)
    ls[i] = lscut[(i * 24)..(i * 24 + 23)].mean(0).val
  end


  ls.length
  gphyscut = gphys.cut("time"=>ts..te) 

  sagyoufile = NetCDF.create('sagyou.nc')
  gphyscut.axnames.each do |dim|
    if dim != "time" then
      sagyoufile.def_dim(dim, gphyscut.coord(dim).length)
    else
      sagyoufile.def_dim('Ls', ls.size)
    end
  end
  #軸定義
  gphyscut.axnames.each do |dim|
    sagyoufile.redef
    if dim != "time" then
      sagyou = sagyoufile.def_var(dim, gphyscut.coord(dim).ntype, [gphyscut.coord(dim).name])
      #属性定義
      for i in 0..gphyscut.coord(dim).att_names.size - 1
        sagyou.put_att(gphyscut.coord(dim).att_names[i], gphyscut.coord(dim).get_att(gphyscut.coord(dim).att_names[i]))
      end
      sagyoufile.enddef
      sagyou.put(gphyscut.coord(dim).val)
    else
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
      sagyoufile.enddef
    end
  end
  # 変数定義
  #  array = Array.new(gphyscut.shape.length -2)
  array = ['lat','Ls']
  sagyoufile.redef
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  time = sagyoufile.var('Ls')
  array1 = Array.new(gphyscut.axnames.length - 3,0)
  array2 = Array.new(gphyscut.axnames.length - 3,0)
  ls.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    sagyou.put(gphyscut[false, layer, (index * 24)..(index * 24 + 23)].mean(0,-1).val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime
end
def zonal_mean_3D_with_value ( dir, iyrs, iyre, value, gphys )
  # 高度を値で指定して東西平均した nc ファイルを返す. 時間軸は Ls にする

  ls = GPhys::IO.open('../PlanetLonFromVE.nc',"PlanetLonFromVE")
  #  ls = GPhys::IO.open(dir+'/'+"PlanetLonFromVE.nc","PlanetLonFromVE")
  lat = gphys.coord("lat")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end

  ts = (iyrs - 1) * daysOfYear * DataNumOfDay
  te = iyre * daysOfYear * DataNumOfDay
  days = daysOfYear*(iyre - iyrs + 1)
  if (gphys.coord("time")[-1].val[0]) < te then
    te = gphys.coord("time")[-1].val[0]
    days = (gphys.coord("time")[-1].val[0])/24
  end
  lscut = ls.cut("time"=>ts..te)
  ls = NArray.sfloat(days)

  for i in 0..(days -1)
    ls[i] = lscut[(i * 24)..(i * 24 + 23)].mean(0).val
  end


  ls.length
  gphyscut = gphys.cut("time"=>ts..te) 

  alt_name = gphys.axnames[-2]

  sagyoufile = NetCDF.create('sagyou.nc')
  gphyscut.axnames.each do |dim|
    if dim != "time" then
      sagyoufile.def_dim(dim, gphyscut.coord(dim).length)
    else
      sagyoufile.def_dim('Ls', ls.size)
    end
  end
  #軸定義
  gphyscut.axnames.each do |dim|
    sagyoufile.redef
    if dim != "time" then
      sagyou = sagyoufile.def_var(dim, gphyscut.coord(dim).ntype, [gphyscut.coord(dim).name])
      #属性定義
      for i in 0..gphyscut.coord(dim).att_names.size - 1
        sagyou.put_att(gphyscut.coord(dim).att_names[i], gphyscut.coord(dim).get_att(gphyscut.coord(dim).att_names[i]))
      end
      sagyoufile.enddef
      sagyou.put(gphyscut.coord(dim).val)
    else
      time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
      time.put_att(lscut.att_names[0], 'planetary longitude')
      for i in 1..lscut.att_names.size-1
        time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
      end
      sagyoufile.enddef
    end
  end
  # 変数定義
  #  array = Array.new(gphyscut.shape.length)
  array = ['lat', 'Ls']
  #  array[-1] = 'Ls'
  sagyoufile.redef
  sagyou = sagyoufile.def_var(gphys.name, gphys.ntype, array)
  for i in 0..gphys.att_names.size-1
    sagyou.put_att(gphys.att_names[i], gphys.get_att(gphys.att_names[i]))
  end
  sagyoufile.enddef
  index = 0
  time = sagyoufile.var('Ls')
  array1 = Array.new(gphyscut.axnames.length - 3,0)
  array2 = Array.new(gphyscut.axnames.length - 3,0)
  ls.each do |times|
    array1.fill(0,0..-1).push(index)
    array2.fill(-1,0..-1).push(index)
    sagyou.put(gphyscut.cut(alt_name => value)[false, (index * 24)..(index * 24 + 23)].mean(0,-1).val, "start"=>array1, "end"=>array2)
    time.put(times, "index"=>[index])
    array1.delete_at(-1)
    array2.delete_at(-1)
    index = index + 1
  end
  sagyoufile.close 
  gphystime = GPhys::IO.open("sagyou.nc", gphys.name)

  return gphystime
end
def local_starting_time_and_ending_time(begining_time, days, lon, vir_ls_dir)
  #与えられた時間と経度からローカルタイムで与えられた経度が0時に合うような時間と引数で与えられた日数回した後の時間を配列で返す
  ls_dir = vir_ls_dir.dup
  ls_dir = add_slash(ls_dir)

  ls = GPhys::IO.open(ls_dir+'PlanetLonFromVE.nc','PlanetLonFromVE')

  if ls.coord("time").get_att('units') == 'hrs'
    time_array = begining_time.divmod(DataNumOfDay)
    time_array[0] = begining_time - time_array[1]
    unless lon == 360 then
      time_array[0] = time_array[0] - lon * 1.0/(360.0/DataNumOfDay)
    end
    time_array[1] = time_array[0] + days * DataNumOfDay

  elsif ls.coord("time").get_att('units') == 'sec'
    time_array = begining_time.divmod(DataNumOfDay * HoursOfSecond)
    time_array[0] = begining_time - time_array[1]
    unless lon == 360 then
      time_array[0] = time_array[0] - lon * 1.0/(360.0/DataNumOfDay) * HoursOfSecond
    end
    time_array[1] = time_array[0] + days * DataNumOfDay * HoursOfSecond
  end
  print("begining_ls=",ls.cut("time"=>time_array[0]).val[0],", ")
  print("time=",time_array[0],"\n")
  print("end_ls=",ls.cut("time"=>time_array[1]).val[0],", ")
  print("time=",time_array[1],"\n")
  return time_array
end

def ls_to_time(iyrs, iyre, vir_dir, ls_array)
  # PlanetLonFromVE.nc から軸 Ls, 変数 time の nc ファイルを作成する. そして, 引数で与えられた Ls に合わせた time を取り出す. 一度 time.nc を作成した場合は作成しない. 
  # ls_array は指定する Ls の配列. 指定したい Ls の数だけ配列に加えて返す 
  # 複数年またぐ場合はバグる可能性が高いので注意.

  dir = vir_dir.dup
  dir = add_slash(dir)
  ls = GPhys::IO.open(dir+"PlanetLonFromVE.nc","PlanetLonFromVE")

  daysOfYear = 0
  DaysOfMonth.each do |i|
    daysOfYear += i
  end


  if ls.coord("time").get_att('units') == 'hrs'
    ts = (iyrs - 1) * daysOfYear * DataNumOfDay
    te = iyre * daysOfYear * DataNumOfDay
  elsif ls.coord("time").get_att('units') == 'sec'
    ts = (iyrs - 1) * daysOfYear * DataNumOfDay * HoursOfSecond
    te = iyre * daysOfYear * DataNumOfDay * HoursOfSecond
  end
  if (ls.coord("time")[-1].val[0]) < te then
    te = ls.coord("time")[-1].val[0]
  end

  if File.exist?("./tmp/time.nc")
    time = GPhys::IO.open("./tmp/time.nc", "time")
    unless time.val[0] == ts && time.val[-1] == te
      #time.close
      system('rm -f ./tmp/time.nc')
    end
  end
  unless File.exist?("./tmp/time.nc") 
    lscut = ls.cut("time"=>ts..te)
    time = NArray.sfloat(lscut.length)

    for i in 0..lscut.coord("time").length-1
      time[i] = lscut.coord("time").val[i]
    end

    sagyoufile = NetCDF.create('./tmp/time.nc')
    #time.nc の軸定義
    sagyoufile.def_dim('Ls', lscut.length)
    #軸の値
    sagyoufile.redef
    ls_to_time = sagyoufile.def_var('Ls', lscut.ntype, ['Ls'])
    ls_to_time.put_att(lscut.att_names[0], 'planetary longitude')
    for i in 1..lscut.att_names.size-1
      ls_to_time.put_att(lscut.att_names[i], lscut.get_att(lscut.att_names[i]))
    end
    sagyoufile.enddef
    # 変数定義
    array = Array.new(lscut.shape.length)
    array[-1] = 'Ls'
    sagyoufile.redef
    sagyou = sagyoufile.def_var("time", lscut.coord("time").ntype, array)
    for i in 0..lscut.coord("time").att_names.size-1
      sagyou.put_att(lscut.coord("time").att_names[i], lscut.coord("time").get_att(lscut.coord("time").att_names[i]))
    end
    sagyoufile.enddef
    index = 0
    ls_num = sagyoufile.var('Ls')
    array1 = [] #Array.new(lscut.coord("time").axnames.length - 1,0)
    array2 = []#Array.new(lscut.coord("time").axnames.length - 1,0)
    time.each do |times|
      array1.fill(0,0..-1).push(index)
      array2.fill(-1,0..-1).push(index)
      sagyou.put(NArray.sfloat(1).fill(times), "start"=>array1, "end"=>array2)
      ls_num.put(lscut.cut("time"=>times).val, "index"=>[index])
      array1.delete_at(-1)
      array2.delete_at(-1)
      index = index + 1
    end
    sagyoufile.close 
    time = GPhys::IO.open("./tmp/time.nc", "time")
  end

  time_array = Array.new
  ls_array.each do |ls|
    print("ls=",ls,", ")
    print("time=", time.cut("Ls"=>ls.to_i).val[0], "\n") 
    time_array << time.cut("Ls"=>ls.to_i).val[0] 
  end

  return time_array
end
