﻿#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#これはU.nc,V.nc,SigDot.ncから擾乱の運動エネルギーを作るスクリプトである
# 2012/10/15 荻原弘尭

#-------------宣言文-------------------
require "numru/gphys"
include NumRu
include Math

#-------------ファイル定義--------------
ufilename = "../U.nc"
vfilename = "../V.nc"
#sigdotfilename = "../SigDot.nc"
#-------------変数定義-------------------
uaux = GPhys::IO.open(ufilename, 'U')
vaux = GPhys::IO.open(vfilename, 'V')
#waux = GPhys::IO.open(sigdotfilename, 'SigDot')
imax,jmax,kmax,tmax = uaux.shape
#khmax = waux.shape[2]

utimenum = uaux.shape[-1].divmod(4000)

utimediv = Array.new(utimenum[0])
#xy_KE = Array.new(utimenum[0]+1)
#xy_EKE = Array.new(utimenum[0]+1)
utimenum[0].times do |divnum|
  var = divnum + 1
  if divnum == 0
    utimediv[divnum] = uaux[0..-1,0..-1,0..-1,0..3999]
#    xy_KE[divnum] = NArray.float(imax,jmax,kmax,4000)
#    xy_EKE[divnum] = NArray.float(imax,jmax,kmax,4000)
  else
    utimediv[divnum] = uaux[0..-1,0..-1,0..-1,(divnum * 4000)..(var * 4000 - 1)]
#    xy_KE[divnum] = NArray.float(imax,jmax,kmax,3999)
#    xy_EKE[divnum] = NArray.float(imax,jmax,kmax,3999)
  end
end
utimediv[utimenum[0]] = uaux[0..-1,0..-1,0..-1,(utimenum[0]*4000)..(utimenum[0]*4000 + utimenum[1]-1)]
#xy_KE[utimenum[0]+1] = NArray.float(imax,jmax,jmax,utimenum[1])
#xy_EKE[utimenum[0]+1] = NArray.float(imax,jmax,jmax,utimenum[1])
vtimenum = vaux.shape[-1].divmod(4000)

vtimediv = Array.new(vtimenum[0])
vtimenum[0].times do |divnum|
  var = divnum + 1
  if divnum == 0
    vtimediv[divnum] = vaux[0..-1,0..-1,0..-1,0..3999]
  else
    vtimediv[divnum] = vaux[0..-1,0..-1,0..-1,(divnum * 4000)..(var * 4000 - 1)]
  end
end
vtimediv[vtimenum[0]] = vaux[0..-1,0..-1,0..-1,(vtimenum[0]*4000)..(vtimenum[0]*4000 + vtimenum[1]-1)]



#--------------計算----------------------
p "test"
(utimenum[0]+1).times do |divnum|
  xy_KE = 0.5*(utimediv[divnum]**2.0 + vtimediv[divnum]**2.0)
  xy_EKE = 0.5*((utimediv[divnum] - utimediv[divnum].average(0))**2.0 + (vtimediv[divnum] - vtimediv[divnum].average(0))**2.0)
  xy_KE.rename("KE")
  xy_KE.set_att("long_name","horizonal kinetic energy per unit mass")
  xy_KE.set_att("units","g m^2 s^-2")
  xy_EKE.rename("EKE")
  xy_EKE.set_att("long_name","horizonal eddy kinetic energy per unit mass")
  xy_EKE.set_att("units","g m^2 s^-2")
  #-------------ファイル出力----------------
  kename = "../KE" + divnum.to_s + ".nc"
  kefile=NetCDF.create(kename)
  GPhys::IO.write(kefile,xy_KE)
  kefile.close
  ekename = "../EKE"+divnum.to_s + ".nc"
  ekefile=NetCDF.create(ekename)
  GPhys::IO.write(ekefile,xy_EKE)
  ekefile.close
end


