﻿#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#これはTauXB.ncとTauYB.ncから|Tau|を作るスクリプトである
# 2012/10/15 荻原弘尭

#-------------宣言文-------------------
$LOAD_PATH.push(Dir.pwd)
require "numru/gphys"
require 'gphys_const_v1.1'
include NumRu
include Math

iyrs = 3
iyre = 3
#-------------ファイル定義--------------
ufilename = "../U.nc"
vfilename = "../V.nc"
windfilename = "../SurfWind.nc"
#-------------変数定義-------------------
daysOfYear = 0
DaysOfMonth.each do |i|
  daysOfYear += i
end

ts = (iyrs - 1) * daysOfYear * DataNumOfDay
te = iyre * daysOfYear * DataNumOfDay
u = GPhys::IO.open(ufilename, 'U')
v = GPhys::IO.open(vfilename, 'V')
if u.shape[-1] < te then
  xy_U = u[false,0,true].cut("time"=>ts..(u.shape[-1]-1))
  xy_V = v[false,0,true].cut("time"=>ts..(u.shape[-1]-1))
else
  xy_U = u[false,0,true].cut("time"=>ts..te)
  xy_V = v[false,0,true].cut("time"=>ts..te)
end

imax,jmax,tmax = xy_U.shape

xy_SurfWind = NArray.float(imax,jmax,tmax)
#--------------計算----------------------
p "test"
for t in 0..tmax-1
p t
  for j in 0..jmax-1
    for i in 0..imax-1
       xy_SurfWind[i,j,t] =
       sqrt((xy_U[i,j,t].val[0])**2.0 + xy_V[i,j,t].val[0]**2.0)
    end
  end
end

wind = xy_U.copy
wind.replace_val(xy_SurfWind)
wind.rename("SurfWind")
wind.set_att("long_name","surface wind")
wind.set_att("units","m s-1")

#-------------ファイル出力----------------
windfile=NetCDF.create(windfilename)
GPhys::IO.write(windfile,wind)
windfile.close
